#pragma once
#include <iostream>
#include <tuple>
#include <vector>
#include <unordered_map>
#include <string>
#include <set>
#include <unordered_set>
#include <array>
#include <ranges>
#include <algorithm>
#include <cmath>

struct Edge {
	std::pair<int, int> nodes;
	int middle_node;

	Edge() = default;
	Edge(int, int);

	Edge operator=(const Edge&);
	bool operator == (const Edge&) const;

	Edge Create_Edge(int, int);
	void Update_Middle_Node(int);

	friend std::istream& operator >>(std::istream&, Edge&);
	friend std::ostream& operator <<(std::ostream&, Edge&);
};

struct Node {
	int node_id;
	std::array<double, 3> coors;
	bool vertex = 0;

	Node() = default;
	Node(int, const std::array<double, 3>&, bool);
	Node(const Node&);

	friend std::istream& operator >>(std::istream&, Node&);
	friend std::ostream& operator<<(std::ostream&, Node&);
};

struct Finite_Element {
	int element_id;
	int material_id;
	std::vector<int> node_id;

	Finite_Element() = default;
	Finite_Element(int, int, const std::vector<int>&);

	friend std::istream& operator >>(std::istream&, Finite_Element&);
	friend std::ostream& operator << (std::ostream&, const Finite_Element&);
};

struct Boundary_Finite_Element {
	int element_id;
	int surface_id;
	std::vector<int> node_id;

	Boundary_Finite_Element() = default;
	Boundary_Finite_Element(int, int, const std::vector<int>&);

	friend std::istream& operator >>(std::istream&, Boundary_Finite_Element&);
	friend std::ostream & operator<<(std::ostream&, const Boundary_Finite_Element&);
};
